SeExpr

Classes | Public Member Functions | Private Attributes | List of all members
SeExpr2::VarBlockCreator Class Reference

A class that lets you register for the variables used by one or more expressions. More...

`#include <VarBlock.h>`

## Classes
class | Ref
| Internally implemented var ref used by SeExpr. More...

## Public Member Functions
int | registerVariable (const std::string &name, const ExprType type)
| Register a variable and return a handle. More...
VarBlock | create (bool makeThreadSafe=false)
ExprVarRef * | resolveVar (const std::string &name) const
| Resolve the variable using anything in the data block (call from resolveVar in Expr subclass) More...

## Private Attributes
int | _nextOffset = 0
std::map< std::string, Ref > | _vars

## Detailed Description

A class that lets you register for the variables used by one or more expressions.

Definition at line 84 of file VarBlock.h.

## Member Function Documentation

## ◆ create()

VarBlock SeExpr2::VarBlockCreator::create | ( | bool | makeThreadSafe = `false` | ) |
| inline

Get an evaluation handle (one needed per thread)

Parameters

  makeThreadSafe | If true, right before evaluating the expression, all data used by the interpreter will be copied to the var block, to make the evaluation thread safe (assuming there's one var block instead per thread) If false or not specified, the old behavior occurs (var block will only hold variables sources and optionally output data, and the interpreter will work on its internal data)

Definition at line 121 of file VarBlock.h.

References _nextOffset.

Referenced by f().

## ◆ registerVariable()

int SeExpr2::VarBlockCreator::registerVariable | ( | const std::string & | name,
|  | const ExprType | type
| ) |  |
| inline

Register a variable and return a handle.

Definition at line 101 of file VarBlock.h.

References _nextOffset, _vars, and SeExpr2::ExprType::dim().

Referenced by f().

## ◆ resolveVar()

ExprVarRef* SeExpr2::VarBlockCreator::resolveVar | ( | const std::string & | name | ) | const
| inline

Resolve the variable using anything in the data block (call from resolveVar in Expr subclass)

Definition at line 126 of file VarBlock.h.

References _vars, and it.

## Member Data Documentation

## ◆ _nextOffset

int SeExpr2::VarBlockCreator::_nextOffset = 0
| private

Definition at line 133 of file VarBlock.h.

Referenced by create(), and registerVariable().

## ◆ _vars

std::map<std::string, Ref> SeExpr2::VarBlockCreator::_vars
| private

Definition at line 134 of file VarBlock.h.

Referenced by registerVariable(), and resolveVar().

The documentation for this class was generated from the following file:

- /build/seexpr/src/SeExpr/src/SeExpr2/VarBlock.h